#include <vector>
#include <math.h>
#include <iostream>
#include <conio.h>
#include <fstream>
#include "histogram.h"
#include "text.h"
#include <curl/curl.h>
#include <sstream>
#include <string>
#include "svg.h"
using namespace std;
struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(istream& in, bool promt)
{
    size_t number_count;
    if (promt)
    {
        cerr << "Enter number count: ";
    }
    in >> number_count;
    Input ik;
    ik.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        in >> ik.numbers[i];
    }
    if (promt)
    {
        cerr << "Enter bin count: ";
    }
    in>> ik.bin_count;
    return ik;
}

size_t write_data(void* items, size_t item_size, size_t item_count, void* ctx)
{
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}


Input
download(const string& address)
{
    stringstream buffer;
    CURL *curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != CURLE_OK)
        {
            fprintf(stderr, "curl_easy_perform() failed: %s\n",curl_easy_strerror(res));
            exit(1);
        }
        if(res == CURLE_OK)
        {
            long req;
            res = curl_easy_getinfo(curl, CURLINFO_REQUEST_SIZE, &req);
            if(!res)
                cerr<<"Request size: %ld bytes:  "<< req;
        }
        curl_easy_cleanup(curl);

    }
    return input_data(buffer, false);
}


int main(int argc, char* argv[])
{
    Input input;
    if (argc > 1)
    {
        input = download(argv[1]);
    }
    else
    {
        input = input_data(cin, true);
    }

    const auto bins = make_histogramm(input.numbers, input.bin_count);
    show_histogram_svg(bins);
}


/*
struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};


Input
input_data(){
    cerr << "Input numbers count: ";
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    cerr << "Input numbers: ";
    for (size_t i = 0; i < number_count; i++)
        {
        cin >> in.numbers[i];
        }
    cerr << "Input bin count: ";
    cin >> in.bin_count;
    return in;
}


int main()
{

	Input in = input_data();

	auto bins = make_histogramm(in.numbers, in.bin_count);

	show_histogram_svg(bins);

	return 0;
}*/
